<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: util/calAfe2fe.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_81f17f03227d7067ce13f3651b0bf66b.html">util</a>
  </div>
</div>
<div class="contents">
<h1>calAfe2fe.c</h1><a href="calAfe2fe_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: calAfe2fe.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a><a class="code" href="util_8h.html#a7613b5168812007047e19cf17cc3efa1">00029</a> <span class="keywordtype">int</span> <a class="code" href="calAfe2fe_8c.html#a7613b5168812007047e19cf17cc3efa1">CalAfe2fe</a>(<a class="code" href="structGridData.html">GridData</a> *gdata,PetscReal *shift,<span class="keywordtype">int</span> *slice_id,Mat *pAIpol)
<a name="l00030"></a>00030 {
<a name="l00031"></a>00031   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00032"></a>00032 
<a name="l00033"></a>00033   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Calculating interpolation matrix fe-&gt;fe\n&quot;</span>);
<a name="l00034"></a>00034 
<a name="l00035"></a>00035   Mat AIpol;
<a name="l00036"></a>00036   ierr = MatCreateMPIAIJ(
<a name="l00037"></a>00037     PETSC_COMM_WORLD,
<a name="l00038"></a>00038     <a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>,
<a name="l00039"></a>00039     <a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,
<a name="l00040"></a>00040     <a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>,PETSC_NULL,<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>,PETSC_NULL,
<a name="l00041"></a>00041     &amp;AIpol
<a name="l00042"></a>00042   );CHKERRQ(ierr);
<a name="l00043"></a>00043   ierr = MatSetFromOptions(AIpol);CHKERRQ(ierr);
<a name="l00044"></a>00044 
<a name="l00045"></a>00045   <span class="comment">/* Set diagonal matrix elements to 1 to make sure we do not interpolate any vectors to 0.</span>
<a name="l00046"></a>00046 <span class="comment">     This also takes care of the boundary nodes, which &quot;fall off the map&quot;.</span>
<a name="l00047"></a>00047 <span class="comment">     Though, if the shift is too large (node not within neighboring elements)</span>
<a name="l00048"></a>00048 <span class="comment">     it also gets interpolated to itself (i.e. not shifted)!</span>
<a name="l00049"></a>00049 <span class="comment">  */</span>
<a name="l00050"></a>00050   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>;i++) {
<a name="l00051"></a>00051     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> k=0;k&lt;<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;k++) {
<a name="l00052"></a>00052       ierr = MatSetValue(
<a name="l00053"></a>00053         AIpol,
<a name="l00054"></a>00054         ND*gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>[i]+k,
<a name="l00055"></a>00055         ND*gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>[i]+k,
<a name="l00056"></a>00056         1.0,
<a name="l00057"></a>00057         INSERT_VALUES
<a name="l00058"></a>00058       );CHKERRQ(ierr);
<a name="l00059"></a>00059     }
<a name="l00060"></a>00060   }
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 <span class="preprocessor">#define DIST 1e-12</span>
<a name="l00063"></a>00063 <span class="preprocessor"></span>  PetscReal tshift[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00064"></a>00064   <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,shift,1,tshift,1);
<a name="l00065"></a>00065   <a class="code" href="griddata_8h.html#acb0e2797b801a795093c32740f2c7256">my_dscal</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,1+<a class="code" href="writedatadat_8c.html#ab8a17bd7aebfe396839620a814ec3e4d">DIST</a>,tshift,1);
<a name="l00066"></a>00066   tshift[0]+=<a class="code" href="writedatadat_8c.html#ab8a17bd7aebfe396839620a814ec3e4d">DIST</a>;
<a name="l00067"></a>00067   tshift[1]+=<a class="code" href="writedatadat_8c.html#ab8a17bd7aebfe396839620a814ec3e4d">DIST</a>;
<a name="l00068"></a>00068   tshift[2]+=<a class="code" href="writedatadat_8c.html#ab8a17bd7aebfe396839620a814ec3e4d">DIST</a>;
<a name="l00069"></a>00069   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Shifting nodes by (%g,%g,%g)\n&quot;</span>,tshift[0],tshift[1],tshift[2]);
<a name="l00070"></a>00070 
<a name="l00071"></a>00071   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Calculating interpolation matrix...\n&quot;</span>);
<a name="l00072"></a>00072   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a>;i++) {
<a name="l00073"></a>00073     ierr = <a class="code" href="progressbar_8c.html#afac4bb91f0e22a14a209a0f60113654d">ProgressBar</a>(i,gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a>,10);
<a name="l00074"></a>00074 
<a name="l00075"></a>00075     <span class="keywordtype">int</span> j;
<a name="l00076"></a>00076     <span class="keywordflow">for</span> (j=0;j&lt;gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>;j++) {
<a name="l00077"></a>00077       <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>[i]==slice_id[j]) <span class="keywordflow">break</span>;
<a name="l00078"></a>00078     }
<a name="l00079"></a>00079     <span class="keywordflow">if</span> (j==gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>) <span class="keywordflow">continue</span>;
<a name="l00080"></a>00080 
<a name="l00081"></a>00081     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> k=0;k&lt;<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>;k++) {
<a name="l00082"></a>00082       <span class="keywordtype">int</span> v;
<a name="l00083"></a>00083       v=gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[NV*i+k];
<a name="l00084"></a>00084 
<a name="l00085"></a>00085       PetscReal p[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>],rhs[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00086"></a>00086 
<a name="l00087"></a>00087       <span class="comment">/* copy Cartesian coordinates */</span>
<a name="l00088"></a>00088       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> m=0;m&lt;<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;m++) {
<a name="l00089"></a>00089         p[m]=gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>[ND*v+m];
<a name="l00090"></a>00090         p[m]+=tshift[m];
<a name="l00091"></a>00091       }
<a name="l00092"></a>00092 
<a name="l00093"></a>00093       <span class="keywordflow">if</span> (
<a name="l00094"></a>00094         <a class="code" href="barycent_8c.html#ac3e1493d687d06e1258e781a9fdf5a90">barycent</a>(
<a name="l00095"></a>00095           p,
<a name="l00096"></a>00096           gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+ND*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[NV*i+0],
<a name="l00097"></a>00097           gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+ND*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[NV*i+1],
<a name="l00098"></a>00098           gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+ND*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[NV*i+2],
<a name="l00099"></a>00099           gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+ND*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[NV*i+3],
<a name="l00100"></a>00100           rhs
<a name="l00101"></a>00101         )
<a name="l00102"></a>00102       ) {
<a name="l00103"></a>00103         <span class="keywordflow">for</span> (<span class="keywordtype">int</span> l=0;l&lt;ND;l++) {
<a name="l00104"></a>00104           PetscReal matele;
<a name="l00105"></a>00105 
<a name="l00106"></a>00106           matele=(1-rhs[0]-rhs[1]-rhs[2]);
<a name="l00107"></a>00107           ierr = MatSetValue(AIpol,
<a name="l00108"></a>00108             ND*v+l,
<a name="l00109"></a>00109             ND*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[NV*i+3]+l,
<a name="l00110"></a>00110           matele,INSERT_VALUES);CHKERRQ(ierr);
<a name="l00111"></a>00111 
<a name="l00112"></a>00112           matele=rhs[0];
<a name="l00113"></a>00113           ierr = MatSetValue(AIpol,
<a name="l00114"></a>00114             ND*v+l,
<a name="l00115"></a>00115             ND*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[NV*i+0]+l,
<a name="l00116"></a>00116           matele,INSERT_VALUES);CHKERRQ(ierr);
<a name="l00117"></a>00117 
<a name="l00118"></a>00118           matele=rhs[1];
<a name="l00119"></a>00119           ierr = MatSetValue(AIpol,
<a name="l00120"></a>00120             ND*v+l,
<a name="l00121"></a>00121             ND*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[NV*i+1]+l,
<a name="l00122"></a>00122           matele,INSERT_VALUES);CHKERRQ(ierr);
<a name="l00123"></a>00123 
<a name="l00124"></a>00124           matele=rhs[2];
<a name="l00125"></a>00125           ierr = MatSetValue(AIpol,
<a name="l00126"></a>00126             ND*v+l,
<a name="l00127"></a>00127             ND*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[NV*i+2]+l,
<a name="l00128"></a>00128           matele,INSERT_VALUES);CHKERRQ(ierr);
<a name="l00129"></a>00129         }
<a name="l00130"></a>00130       }
<a name="l00131"></a>00131     }
<a name="l00132"></a>00132   }
<a name="l00133"></a>00133 
<a name="l00134"></a>00134   ierr = <a class="code" href="progressbar_8c.html#afac4bb91f0e22a14a209a0f60113654d">ProgressBar</a>(1,1,10);
<a name="l00135"></a>00135 
<a name="l00136"></a>00136   PetscInfo(0,<span class="stringliteral">&quot;AIpol matrix assembly complete\n&quot;</span>);
<a name="l00137"></a>00137   ierr = MatAssemblyBegin(AIpol,MAT_FINAL_ASSEMBLY);CHKERRQ(ierr);
<a name="l00138"></a>00138   ierr = MatAssemblyEnd(AIpol,MAT_FINAL_ASSEMBLY);CHKERRQ(ierr);
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 <span class="preprocessor">#if 0</span>
<a name="l00141"></a>00141 <span class="preprocessor"></span>  <span class="comment">/* This is taken care of by setting the diagonal to 1 above. */</span>
<a name="l00142"></a>00142 
<a name="l00143"></a>00143   <span class="comment">/* Make sure all nodes are getting interpolated */</span>
<a name="l00144"></a>00144   <span class="comment">/* Since all nodes are shifted only a small amount so they are within an element they already</span>
<a name="l00145"></a>00145 <span class="comment">   * belong to, there has to be a non-zero diagonal matrix element. */</span>
<a name="l00146"></a>00146   Vec Vdiag;
<a name="l00147"></a>00147   ierr = VecDuplicate(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;Vdiag);CHKERRQ(ierr);
<a name="l00148"></a>00148 
<a name="l00149"></a>00149   <span class="comment">/* This could be rather slow for big matrices: */</span>
<a name="l00150"></a>00150   ierr = MatGetDiagonal(AIpol,Vdiag);CHKERRQ(ierr);
<a name="l00151"></a>00151 
<a name="l00152"></a>00152   PetscReal *d;
<a name="l00153"></a>00153   ierr = VecGetArray(Vdiag,&amp;d);CHKERRQ(ierr);
<a name="l00154"></a>00154   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>;i++) {
<a name="l00155"></a>00155     <span class="keywordflow">if</span> (d[gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>[i]]==0.0) d[gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>[i]]=1.0;
<a name="l00156"></a>00156   }
<a name="l00157"></a>00157   ierr = VecRestoreArray(Vdiag,&amp;d);CHKERRQ(ierr);
<a name="l00158"></a>00158 
<a name="l00159"></a>00159   ierr = MatDiagonalSet(AIpol,Vdiag,INSERT_VALUES);CHKERRQ(ierr);
<a name="l00160"></a>00160 <span class="preprocessor">#endif</span>
<a name="l00161"></a>00161 <span class="preprocessor"></span>
<a name="l00162"></a>00162   ierr = <a class="code" href="printmatinfo_8c.html#a8c62a6053be02438e1bf2da1efa06f1f">PrintMatInfoAll</a>(AIpol);CHKERRQ(ierr);
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 <span class="comment">/* DEBUG</span>
<a name="l00165"></a>00165 <span class="comment">  PetscPrintf(PETSC_COMM_WORLD,&quot;deb01: AIpol\n&quot;);</span>
<a name="l00166"></a>00166 <span class="comment">  ierr = MatView(AIpol,PETSC_VIEWER_STDOUT_WORLD);CHKERRQ(ierr);</span>
<a name="l00167"></a>00167 <span class="comment">*/</span>
<a name="l00168"></a>00168 
<a name="l00169"></a>00169   *pAIpol=AIpol;
<a name="l00170"></a>00170 
<a name="l00171"></a>00171   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00172"></a>00172 }
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

